import numpy as np
import pickle
import matplotlib.pyplot as plt
import seaborn as sb
import scipy.stats as ss
"""
       MCMCサンプルの読み込み
"""
with open('xy.pkl', 'rb') as f:
    xy = pickle.load(f)
with open('rhos.pkl', 'rb') as f:
    rhos = pickle.load(f)
with open('xmus.pkl', 'rb') as f:
    xmus = pickle.load(f)
with open('xsgms.pkl', 'rb') as f:
    xsgms = pickle.load(f)
with open('ymus.pkl', 'rb') as f:
    ymus = pickle.load(f)
with open('ysgms.pkl', 'rb') as f:
    ysgms = pickle.load(f)
"""
       事後分布の描画
"""
sb.kdeplot(rhos)
plt.show()

sb.kdeplot(xmus)
plt.show()

sb.kdeplot(ymus)
plt.show()

sb.kdeplot(xsgms)
plt.show()

sb.kdeplot(ysgms)
plt.show()
"""
        データのプロットと
        推定された２変量正規分布のグラフ
"""
rho = np.median(rhos)
xmu = np.median(xmus)
xsgm = np.median(xsgms)
ymu = np.median(ymus)
ysgm = np.median(ysgms)

mins = np.min(xy, axis=0) - np.array([2, 2])
maxs = np.max(xy, axis=0) + np.array([2, 2])
x_range = np.linspace(mins[0], maxs[0], 100)
y_range = np.linspace(mins[1], maxs[1], 100)
X, Y = np.meshgrid(x_range, y_range)
xypos = np.dstack((X, Y))
Z = ss.multivariate_normal.pdf(xypos, [xmu, ymu],
                               [[xsgm**2, xsgm*ysgm*rho],
                                [ysgm*xsgm*rho, ysgm**2]])
fig = plt.figure()
ax = fig.add_subplot(111)
ax.plot(xy.T[0], xy.T[1], 'o')      #  データの散布図
ax.contour(x_range, y_range, Z)     #  正規分布の等高線図
plt.title(fr'$\rho$={rho:.3f}', fontsize=20)
plt.show()
