import pickle
import matplotlib.pyplot as plt
import seaborn as sb
import numpy as np
import scipy.stats as ss

with open('x.pkl', 'rb') as f:
    x = pickle.load(f)

with open('mus.pkl', 'rb') as f:
    mus = pickle.load(f)
    
with open('sgms.pkl', 'rb') as f:
    sgms = pickle.load(f)


sb.kdeplot(mus)
plt.show()

sb.kdeplot(sgms)
plt.show()
#
#      データと分析結果のグラフの表示
#
mu = np.median(mus)      #  中央値を推定値とする
sgm = np.median(sgms)    #  中央値を推定値とする
x_min = np.min(x)
x_max = np.max(x)
x_coord = np.linspace(x_min, x_max, 1000)
y_coord = ss.norm.pdf(x_coord, loc=mu, scale=sgm)    #  正規分布の値
plt.hist(x, density=True)
plt.plot(x_coord, y_coord, lw=3, label=f'mu={mu:.1f}\nsgm={sgm:.1f}')
plt.xlabel('x', fontsize=18)
plt.ylabel('Density', fontsize=14)
plt.legend()
plt.show()
